/// Copyright Thomas Nagy 2007
/// License: QPL

#include <QSpinBox>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QDialogButtonBox>
#include <QtGui/QGridLayout>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QSpacerItem>
#include <QTreeWidget>
#include <QTextEdit>
#include <QHeaderView>
#include <QDirModel>
#include <QCompleter>

#include <QtDebug>

#include "Iztpr.h"
#include "tslabels.h"

/*!
 * @praise Vishnu
 */
asdl::asdl(QWidget *felvnl):
	QDialog(felvnl)
<%
	QGridLayout *vnl=new QGridLayout(this);

	QLabel *fldlgz;

	fldlgz=new QLabel(this);
	fldlgz->setText(ts_323);
	vnl->addWidget(fldlgz,0,0,1,1);

	fldlgz=new QLabel(this);
	fldlgz->setText(ts_324);
	vnl->addWidget(fldlgz,1,0,1,1);

	jlzpnt=new QSpinBox(this);
	vnl->addWidget(jlzpnt,0,1,1,1);

	adelk=new QSpinBox(this);
	vnl->addWidget(adelk,1,1,1,1);

	QSpacerItem *spacerItem=new QSpacerItem(0,0,QSizePolicy::Minimum,QSizePolicy::Expanding);
	vnl->addItem(spacerItem,2,1,1,1);

	QDialogButtonBox *mgmnkl=new QDialogButtonBox(this);
	mgmnkl->setOrientation(Qt::Horizontal);
	mgmnkl->setStandardButtons(QDialogButtonBox::Cancel|QDialogButtonBox::NoButton|QDialogButtonBox::Ok);

	vnl->addWidget(mgmnkl,3,0,1,2);

	connect(mgmnkl,SIGNAL(accepted()),this,SLOT(accept()));
	connect(mgmnkl,SIGNAL(rejected()),this,SLOT(reject()));

	QSize size(321,120);
	size=size.expandedTo(minimumSizeHint());
	resize(size);
%>

#include "Iztpr.moc"

