/// Copyright Thomas Nagy 2007
/// License: QPL

#include <QVariant>
#include <QCoreApplication>
#include <QAction>
#include <QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QDialogButtonBox>
#include <QtGui/QGridLayout>
#include <QLabel>
#include <QLineEdit>
#include <QSpacerItem>
#include <QTreeWidget>
#include <QTextEdit>
#include <QHeaderView>
#include <QDirModel>
#include <QCompleter>
#include <QtDebug>
#include "Vadrt.h"
#include "tslabels.h"

/*!
 * @praise Vishnu
 */
vadrt::vadrt(QWidget *felvnl):
	QDialog(felvnl)
<%
	QGridLayout *vnl=new QGridLayout(this);

	QLabel *fldlgz;

	fldlgz=new QLabel(this);
	fldlgz->setText(ts_160);
	vnl->addWidget(fldlgz,0,0,1,1);

	fldlgz=new QLabel(this);
	fldlgz->setText(ts_161);
	vnl->addWidget(fldlgz,1,0,1,1);

	fldlgz=new QLabel(this);
	fldlgz->setText(ts_162);
	vnl->addWidget(fldlgz,2,0,1,1);

	fldlgz=new QLabel(this);
	fldlgz->setText(ts_163);
	vnl->addWidget(fldlgz,3,0,1,1);

	kitzjl=new QLineEdit(this);
	vnl->addWidget(kitzjl,0,1,1,1);

	jlzpnt=new QLineEdit(this);
	vnl->addWidget(jlzpnt,1,1,1,1);

	irnyjl=new QLineEdit(this);
	vnl->addWidget(irnyjl,2,1,1,1);

	adelk=new QLineEdit(this);
	vnl->addWidget(adelk,3,1,1,1);

	QSpacerItem *spacerItem=new QSpacerItem(0,0,QSizePolicy::Minimum,QSizePolicy::Expanding);
	vnl->addItem(spacerItem,4,1,1,1);

	QDialogButtonBox *mgmnkl=new QDialogButtonBox(this);
	mgmnkl->setOrientation(Qt::Horizontal);
	mgmnkl->setStandardButtons(QDialogButtonBox::Cancel|QDialogButtonBox::NoButton|QDialogButtonBox::Ok);

	vnl->addWidget(mgmnkl,5,0,1,2);

	connect(mgmnkl,SIGNAL(accepted()),this,SLOT(accept()));
	connect(mgmnkl,SIGNAL(rejected()),this,SLOT(reject()));

	QSize size(321,120);
	size=size.expandedTo(minimumSizeHint());
	resize(size);
%>

#include "Vadrt.moc"

